/************************************************************************/
/*                                                                      */
/*  NAME : SC61860 CROSS ASSEMBLER SOURCE CODE                          */
/*  FILE : hd61700.c                                                    */
/*  Copyright (c)  'BLUE' 2003-2024                                 */
/*                                                                      */
/*  REVISION HISTORY:                                                   */
/*  Rev : 0.01  2006.11.07  ŏ̃o[W                            */
/*  Rev : 0.02  2021.08.24  DL^,CASE1Ήǉ                    */
/*                          unsigned long -> unsigned int ɕύX        */
/*  Rev : 0.03  2022.06.27  MVWP(0x35)ǉ                          */
/*              2022.10.15  2pXڂOutBuf@C             */
/*              2024.01.13  RgC                                */
/*                                                                      */
/************************************************************************/
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<fcntl.h>
#include"SC61860.h"
/*------------------------------------------------------------------*/
/*  萔`                                                        */
/*------------------------------------------------------------------*/
#define FORDOS  		0			/* 1:DOSpɃRpC      */
#define WITH_EOF		1			/* 1:o̓t@CEOFt  */
#if FORDOS
char	name[]	="SC61860 ASSEMBLER FOR DOS ";	/* AZu   */
#else
char	name[]	="SC61860 ASSEMBLER ";	/* AZu           */
#endif
char	rev[]	="Rev 0.03";			/* Revision                 */
/* p\ */
char	LabelStr[]	= "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789@_";
char	DecStr[]	= "0123456789";
char	HexStr[]	= "0123456789ABCDEFabcdef";
/*------------------------------------------------------------------*/
/*  ϐ`                                                        */
/*------------------------------------------------------------------*/
char	SrcFile[MAXLINE];			/* \[Xt@C             */
char	IncFile[MAXLINE];			/* CN[ht@C       */
char	BinFile[MAXLINE];			/* oCit@C           */
char	LstFile[MAXLINE];			/* Xgt@C             */
char	OutFile[MAXLINE];			/* o̓t@C               */
char	ExeFile[MAXLINE];			/* st@C               */
FILE	*IncFD[MAXINC];				/* INCLUDEt@CfBXNv^*/
FILE	*SrcFD;						/* \[Xt@CfBXNv^ */
FILE	*BinFD;						/* Binaryt@CfBXNv^ */
FILE	*LstFD;						/* Xgt@CfBXNv^ */
FILE	*OutFD;						/* o̓t@CfBXNv^   */
unsigned short	pass;				/* AZupX(0A1)       */
unsigned short	SetLabel;			/* /SET IvVo^        */
SETOPT			SetTbl[MAXOPT];		/* /SETIvV\         */
unsigned short	OutType;			/* 0:BASICA1:PBF`           */
unsigned short	pr;					/* ʏo̓tO               */
unsigned short	Tab;				/* TABo̓tO                */
unsigned int 	StartAdr;			/* AZuJnAhX       */
unsigned int 	ExecAdr;			/* sJnAhX             */
unsigned int 	AsmAdr;				/* AZuAhX           */
unsigned short	StartAdrFlag;		/* AZuJnAhXtO */
unsigned short	ExecAdrFlag;		/* sJnAhXtO       */
unsigned short	LabelCnt;			/* xo^                 */
LBL				* LabelTbl;			/* xo^e[u|C^   */
struct	outtbl	OutTbl;				/* \͌ʃe[u         */
unsigned char*	OutBuf;				/* ߏo̓obt@|C^     */
char			calcwk[MAXLINE+2];	/* xZobt@           */
int				CalcPtr;			/* Zobt@|C^         */
unsigned short	Ckind;				/* Z̖̉tO       */
int				IfLevel;			/* if`endif x             */
unsigned char	AsmFlag;			/* AZu֎~/          */
unsigned char	IfStk[IFLEVEL];		/* AZu֎~/X^bN  */
unsigned short	ListFlag;			/* Xgo̓tO(0:o)     */
unsigned short	LineFeed;			/* ejectvtO(1:v)  */
unsigned short	IncLevel;			/* INCLUDEx(x1܂ŉ) */
unsigned short	SrcLine;			/* \[XXgsԍ           */
unsigned short	IncLine[MAXINC];	/* CN[hXgsԍ     */
char 			oprwk[MAXLEN+2];	/* jjbN/Iyhp[N*/
									/* rpɒӂ邱     */

/*------------------------------------------------------------------*/
/*  vg^Cv錾                                                */
/*------------------------------------------------------------------*/
int main(int argc, char *argv[]);
int AsmProcess( char * );
int InitAsm( char * File );
void ClearFlag( void );
int AsmLine( void );
int AsmCodeSet( void );
int SetLabelTbl( char * buff , unsigned short adr );
int GetLabelAdr( char * buff , unsigned short * adr );
int GetMacKind( char * buff );
unsigned short GetMnemonicKind( char * buff );
int CheckLabel( char * buff );
int ChgCode( char * dst , char * src );
int GetLine( FILE *fd ,char *buff );
int GetParam( char *buff );
int GetData( char *buff , unsigned short * data );
int GetCalcData( char * buff , unsigned short * kind ,unsigned short * adr );
int CalcVal(unsigned short * value );
int CalcVal0(unsigned short * value );
int CalcValShift(unsigned short * value );
int CalcVal1(unsigned short * value );
int CalcVal2(unsigned short * value );
int CalcVal3( unsigned short *value );
int GetValue(unsigned short *value );
int CheckSetOpt( char * name );
int CheckSetLbl( char * name ,unsigned short sts );
int IncludeBin( unsigned short *cnt ,char *File );
int ReadBin( unsigned int * Size );
int ReadBmp( unsigned int * Size );
void PrintList( int cnt );
void ErrPut( int cnt , int err );

/**********************************************************************/
/*   main    : main routine                                           */
/*                                                                    */
/*       : C                                             */
/*       : R}hCIvV                               */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int main(int argc, char *argv[])
{
int	rc,i;
char * ptr;

	/* No[W̕\ */
	printf( "%s%s\n",name,rev );

	/* R}hC̃`FbN */
	if( argc > (MAXOPT*2) ){
		printf("Invalid Parameters.\n");
		exit(1);
	}

	/* \[Xt@Cw肠 */
	if ( !argv[1] ){
		printf("Invalid Source File Name.\n");
		exit (1);
	}
	/* t@C̍쐬 */
	sprintf( SrcFile , "%s" , argv[1] );

	/* SETIvV */
	SetLabel = 0;
	memset( oprwk , 0 , MAXLEN+2 );
	memset( SetTbl , 0 , sizeof(SetTbl) );

	/* IvV */
	pr = 0;
	Tab = 0;
	OutType = 0;
	/* NIvV擾 */
	i=2;
	while( argv[i] ){
		/* TABXgo͑I */
		if (!strcmp("/tab",argv[i])||!strcmp("/TAB",argv[i])){ Tab = 1;i++; continue; }
		/* PBFt@Co͑I */
		if (!strcmp("/p",argv[i])||!strcmp("/P",argv[i])){ OutType = 1;i++; continue; }
		/* IntelHEX(8bit)t@Co͑I */
		if (!strcmp("/hex",argv[i])||!strcmp("/HEX",argv[i])){ OutType = 2;i++; continue; }
		/* oCit@Co͑I */
		if (!strcmp("/b",argv[i])||!strcmp("/B",argv[i])){ OutType = 3;i++; continue; }
		/***********************/
		/* o^    */
		/***********************/
		/* R}hCo */
		sprintf( oprwk , "%s" , argv[i] );
		/* "=" */
		if ( ptr = strchr( oprwk , '=' ) ){
			if( ((int)(ptr - oprwk ) > MAXNAME )||( strlen(ptr) > (MAXNAME+1) ) ){
				/* R}hCُ */
				printf("Invalid /SET name.\n");
				exit(1);
			}
			/* o^x̎擾 */
			memcpy(SetTbl[SetLabel].ent,oprwk,(int)(ptr-oprwk));
			/* 擾 */
			sprintf(SetTbl[SetLabel].let,"%s", ptr+1 );
			/* =Eӂ܂́AV{o^ȂG[IƂ */
			if (!strcmp(SetTbl[SetLabel].ent,SetTbl[SetLabel].let)||!CheckSetOpt( SetTbl[SetLabel].ent ) ){
				/* R}hCُ */
				printf("Invalid /SET name.\n");
				exit(1);
			}
			/* 16i\L0x$0ɏC */
			if( !memcmp(SetTbl[SetLabel].let,"0x",2)||!memcmp(SetTbl[SetLabel].let,"0X",2) ){
				SetTbl[SetLabel].let[0]='$';
				SetTbl[SetLabel].let[1]='0';
			}
			/* SETV{XV */
			SetLabel++;
			i++;
			continue;
		}
		/* R}hCُ */
		printf("Invalid Parameters.\n");
		exit(1);
	}
	/* AZu */
	rc = AsmProcess( SrcFile );

	return(rc);
}

/**********************************************************************/
/*   InitAsm : Initialize Assembler Process                           */
/*                                                                    */
/*       : AZu                                   */
/*       : \[Xt@C                                       */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int InitAsm( char * File )
{
char * fptr;
char out[8];

	/* o̓obt@|C^ */
	OutBuf = 0;
	/* etO/JE^ */
	ClearFlag();
	/* LABELe[u */
	LabelCnt = 0;
	LabelTbl = 0;
	/* t@C̍쐬 */
	sprintf( LstFile , "%s" , File );
	sprintf( OutFile , "%s" , File );
	/* st@C쐬 */
	if(fptr = strrchr(File,  0x5c ))
		ChgCode( ExeFile , &fptr[1] );
	else ChgCode( ExeFile , File );

	/* Listt@C쐬 */
	if ((fptr = strrchr(LstFile,  '.' )))
		sprintf( fptr,".lst" );
	else	strcat( LstFile, ".lst" ); 

	/* o̓t@C쐬 */
	switch ( OutType ){
	case 0:
		sprintf( out ,".dmp" );
		break;
	case 1:
		sprintf( out ,".pbf" );
		break;
	case 2:
		sprintf( out ,".hex" );
		break;
	case 3:
		sprintf( out ,".bin" );
		break;
	}
	if ((fptr = strrchr(OutFile, '.' )))
		sprintf( fptr,"%s", out );
	else	strcat( OutFile, out );

	/* ̓t@Clst/bas/pbfw̏ꍇAG[I */
	if( !strcmp(OutFile,SrcFile) || !strcmp(LstFile,SrcFile) ){
		printf("Invalid Source File Name.\n");
		return INZERR;
	}
	/* \[Xt@COPEN */
	if ( ( SrcFD = fopen( SrcFile ,"rb" ) ) <= 0 ){
		printf("Invalid Source File Name.\n");
		return INZERR;
	}
	printf( "Input : %s \n", SrcFile );
	/* t@CWȏ̏ꍇA[jO\ */
	if ( (strrchr(ExeFile, '.' ) - ExeFile ) > 8 ){
		printf("Warning! File Name Over 8 Chracters.\n");
	}
	return NORM;
}

/**********************************************************************/
/*   ClearFlag : Clear Flag Data                                      */
/*                                                                    */
/*       : etO                                       */
/*       : Ȃ                                                   */
/*   o    : Ȃ                                                   */
/*                                                                    */
/**********************************************************************/
void ClearFlag( void )
{
	/* AZuJnAhX */
	SrcLine = 0;
	ListFlag = 0;
	LineFeed = 0;
	IncLevel = 0;
	AsmAdr = 0;
	ExecAdr = 0;
	StartAdr = 0;
	StartAdrFlag = 0;
	ExecAdrFlag = 0;
	/* AZu */
	AsmFlag = 0;
	/* iflXgx */
	IfLevel = 0;
	/* if`endifX^bN */
	memset( IfStk , 0 , sizeof(IfStk) );
	/* include񏉊 */
	memset( IncLine , 0 ,sizeof(IncLine));
	memset( IncFD , 0 , sizeof(IncFD));

}

/**********************************************************************/
/*   AsmProcess : Assembler Process Main Routine                      */
/*                                                                    */
/*       : AZu                                         */
/*       : \[Xt@C                                       */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int AsmProcess( char * File )
{
char * fptr;
char out[8];
int rc,rc2,i,n;
unsigned short sum,sts;
unsigned short LineCnt;	/* sԍJE^ */
unsigned int  OutCnt,cnt;	/* o̓oCg */
unsigned int  BuffSize;	/* o̓obt@TCY */
LBL *Label;
LBL *Labelwk;
	/* ݒ */
	if( rc = InitAsm( File ) ) return rc;

	/* SETIvVs(ml̂݃V{o^) */
	if ( SetLabel ){
		/* xo^s */
		for ( i = 0 ; i < SetLabel ; i++ ){
			/* l擾 */
			if( !( rc = GetData( SetTbl[i].let , &sts ) ) ){
				/* x`FbN */
				if ( rc = CheckLabel( SetTbl[i].ent ) ){
					/* G[\ */
					printf("Invalid /SET name.\n");
					goto asm_end;
				}
				/* xe[uɓo^ */
				if(rc = SetLabelTbl( SetTbl[i].ent , sts )){
					/* G[\ */
					printf("Invalid /SET name.\n");
					goto asm_end;
				}
			}
			/* l̓xł */
			else{
				/* x`FbN */
				if ( rc = CheckLabel(SetTbl[i].let) ){
					/* G[\ */
					printf("Invalid /SET name.\n");
					goto asm_end;
				}
			}
		}
	}
	/* Xgt@COPEN */
	if ( ( LstFD = fopen( LstFile ,"w" ) ) <= 0 ){
		printf("File Create Error.\n");
		goto asm_end;
	}

	/* PpXڃxe[u쐬 */
	LineCnt = 0;
	pass = 0;
	while( !rc ){
		rc = AsmLine();
		if ( rc && (rc != EOFERR) ) {
			/* G[\ */
			ErrPut( LineCnt , rc );
			goto asm_end;
		}
		/* sԍXV */
		LineCnt = !IncLevel ? ++SrcLine : ++IncLine[IncLevel-1];
	}
	/* #if`#enfiflXgُ픭 */
	if ( IfLevel ){
		/* G[\ */
		ErrPut( LineCnt-1 , IFNEST );
		goto asm_end;
	}
	/* o̓TCY߂ */
	OutCnt = AsmAdr;
	/* R[h͍őobt@͈͓Ɏ܂ */
	if ( (BuffSize = (OutCnt - StartAdr) ) > MAXOBJ ){
		/* o̓obt@I[o[ */
		ErrPut( LineCnt-1 , AOFLOW );
		goto asm_end;
	}
	/* \[Xt@C擪ɃV[N */
	if( fseek(SrcFD , 0 , SEEK_SET )){
		printf("Sorce File Seek Error.\n");
		goto asm_end;
	}
	/* PpXڏI */
	printf( " PASS 1 END \n" );

	/* o̓obt@mۂ(1Byte]Ɏ) */
	if ( !( OutBuf = (unsigned char*)malloc( (size_t)(BuffSize+1) ) ) ){
		printf("Output Buffer Not Allocated.\n");
		goto asm_end;
	}
	/* o̓obt@ */
	for( i = 0 ; i < BuffSize ; i++ ){
		OutBuf[i] = 0;
	}
	/* sԍAAZuAhX */
	ClearFlag();
	LineCnt = 0;
	OutCnt = 0;

	/* Xgo͊Jn */
	fprintf( LstFD , "%s%s - ",name,rev );
	fprintf( LstFD ,"ASSEMBLY LIST OF [%s]\n", SrcFile );

	/* QpXڃxAhX𔽉fA߃R[ho͂ */
	rc = 0; rc2 = 0;pass++;
	while( !rc && !rc2 ){
		rc = AsmLine();
		if ( rc && (rc != EOFERR) ) {
			/* G[\ */
			ErrPut( LineCnt , rc );
			goto asm_end;
		}
		/* AZuԂ̎̂ݎs */
		if (!AsmFlag){
			if ( rc2 = AsmCodeSet() ){
				ErrPut( LineCnt , rc2 );
				goto asm_end;
			}
			/* R[h̓obt@͈͓Ɏ܂ */
			if ( ( OutCnt + (unsigned int)OutTbl.byte ) > BuffSize ){
				/* o̓obt@I[o[ */
				ErrPut( LineCnt , AOFLOW );
				goto asm_end;
			}
			/* Xgt@Co */
			PrintList( LineCnt );
			/* R[ho͗v */
			if ( OutTbl.byte ){
				/* ʏ햽߁^^ߎʎo */
				ChgCode( oprwk , OutTbl.opr[0] );
				sts = GetMnemonicKind( oprwk );
				switch( sts ){
				/* ORG/DS */
				case OP_ORG:
				case OP_DS:
					break;
				/* #INCBIN */
				case OP_INCBIN:
					/* oCiR[ho */
					memcpy( &OutBuf[OutCnt] , OutTbl.bcode , OutTbl.byte );
					/* obt@J */
					free( OutTbl.bcode );
					break;
				default:
					/* ORG/DS/#INCBIN ߈ȊOȂAf[^o */
					memcpy( &OutBuf[OutCnt] , OutTbl.code , OutTbl.byte );
					break;
				}
			}
			/* o̓oCgXV */
			OutCnt += OutTbl.byte;
		}
		else if (AsmFlag==1){
			/* Xgt@Co */
			PrintList( LineCnt );
			AsmFlag++;
		}
		/* sԍXV */
		LineCnt = !IncLevel ? ++SrcLine : ++IncLine[IncLevel-1];
	}
	/* AZuI */
	printf( " PASS 2 END\n" );
	printf("ASSEMBLY COMPLETE, NO ERRORS FOUND\n");
	fprintf(LstFD,"\nASSEMBLY COMPLETE, NO ERRORS FOUND\n");

	/* xe[uo͂ */
	if ( LabelCnt ){
		/* wb_o */
		fprintf( LstFD ,"\n%s%s - ",name,rev );
		fprintf( LstFD ,"MAP LIST OF [%s]\n", SrcFile );
		fprintf( LstFD ," LABEL           : ADDRESS(hex)    LABEL           : ADDRESS(hex)\n" );
		fprintf( LstFD ,"------------------------------------------------------------------\n" );
		Label = LabelTbl;
		i = 0;
		while ( Label ){
			if (!(i&1))	fprintf( LstFD ," %-16s:   %04Xh        " , Label->name , Label->adr );
			else fprintf( LstFD ," %-16s:   %04Xh\n" , Label->name , Label->adr );
			Label = Label->np;
			i++;
		}
		if (i&1) fprintf( LstFD ,"\n");
	}
	/* AZuo */
	fprintf( LstFD ,"\n START ADDRESS   = %04Xh\n", StartAdr );
	fprintf( LstFD ," END ADDRESS     = %04Xh\n", AsmAdr-1 );
	fprintf( LstFD ," EXECUTE ADDRESS = %04Xh\n", ExecAdr );

	/* o̓t@C쐬 */
	if ( OutCnt ){
		/* o͗pt@COPEN */
		if ( ( OutFD = fopen( OutFile , (OutType==3 ? "wb":"w") ) ) <= 0 ){
			printf("File Create Error.\n");
			goto asm_end;
		}
		/* st@C쐬 */
		if ( !ExecAdrFlag ) sprintf( out ,".BIN" );
		else sprintf( out ,".EXE" );
		if ((fptr = strrchr(ExeFile, '.' ))) sprintf( fptr ,"%s" ,out );
		else strcat( ExeFile ,out );
		/* t@C쐬 */
		switch( OutType ){
		/* _v(dmp)t@C쐬 */
		case 0:
			for ( cnt = 0 , n = 0 , sum = 0 ; cnt < OutCnt ; cnt ++ ){
				/* AhXo */
#if FORDOS
				if (!n) fprintf( OutFD ,"%04X : ", (unsigned short)StartAdr );
#else
				if (!n) fprintf( OutFD ,"%04X : ", StartAdr );
#endif
				fprintf( OutFD ,"%02X ", OutBuf[cnt] );
				sum += OutBuf[cnt];
				n++;
				/* `FbNT/so */
				if ( n >= 8 ){
					fprintf( OutFD ,": %02X\n", sum&0xff );
					StartAdr += n;
					n = 0;
					sum = 0;
				}
			}
			/* `FbNTo */
			if (n) fprintf( OutFD ,": %02X\n", sum&0xff );
			break;
		/* pbft@C쐬v */
		case 1:
#if FORDOS
			fprintf( OutFD ,"%s,%u,%u,%u\n", ExeFile,(unsigned short)StartAdr,(unsigned short)(AsmAdr-1),(unsigned short)ExecAdr );
#else
			fprintf( OutFD ,"%s,%u,%u,%u\n", ExeFile,StartAdr,AsmAdr-1,ExecAdr );
#endif
			for ( cnt = 0 , n = 0 , sum = 0 ; cnt < OutCnt ; cnt ++ ){
				fprintf( OutFD ,"%02X", OutBuf[cnt] );
				sum += OutBuf[cnt];
				n++;
				/* `FbNT/so */
				if ( n >= 120 ){
					fprintf( OutFD ,",%u\n", sum );
					n = 0;
					sum = 0;
				}
			}
			/* EOFo */
			if (n) fprintf( OutFD ,",%u\n", sum );
			break;
		/* IntelHEX(8bit)t@C쐬 */
		case 2:
			for ( cnt = 0 , n = 0 , sum = 0 ; cnt < OutCnt ; cnt ++ ){
				/* oCg/AhX/f[^ʂo */
				if (!n){
#if FORDOS
					fprintf( OutFD ,":%02X",( (OutCnt-cnt)>=16 ? 16:(OutCnt-cnt) ) );
					fprintf( OutFD ,"%04X00",(unsigned short)StartAdr );
#else
					fprintf( OutFD ,":%02X%04X00",( (OutCnt-cnt)>=16 ? 16:(OutCnt-cnt) ),StartAdr );
#endif
					sum = ( (OutCnt-cnt)>=16 ? 16:(OutCnt-cnt) ) + (StartAdr>>8) + (StartAdr&0xff);
				}
				/* f[^1oCg o */
				fprintf( OutFD ,"%02X", OutBuf[cnt] );
				sum += OutBuf[cnt];
				n++;
				/* `FbNT/so */
				if ( n >= 16 ){
					fprintf( OutFD ,"%02X\n", (0x100-(sum&0xff)) );
					StartAdr += n;
					n = 0;
					sum = 0;
				}
			}
			/* `FbNTói[j */
			if (n) fprintf( OutFD ,"%02X\n", (0x100-(sum&0xff)) );
			/* AJ[o */
			fprintf( OutFD ,"%s",":00000001FF\n" );
			break;
		/* oCit@Co */
		case 3:
			for ( cnt = 0 ; cnt < OutCnt ; cnt++ ){
				/* f[^o */
				fputc( OutBuf[cnt] , OutFD );
			}
			break;
		}
#if WITH_EOF
		/* EOFo */
		if ( OutType != 3 )
			fprintf( OutFD ,"%c",0x1a );
#endif
		/* o̓t@CN[Y */
		fclose(OutFD);
	}

asm_end:
	/* xe[u */
	Label = LabelTbl;
	while ( Label ){
		Labelwk = Label->np;
		free( Label );
		Label = Labelwk;
	}
	/* o̓obt@ */
	if ( OutBuf ) free( OutBuf );
	/* INCLUDEt@CN[Y */
	if ( IncLevel ){
		for ( i = 0 ; i < IncLevel ;i++){
			fclose( IncFD[i] );
		}
	}
	/* t@CN[Y */
	fclose(SrcFD);
	fclose(LstFD);

	return rc;
}
/**********************************************************************/
/*   AsmLine : Assembler Process ( one line )                         */
/*                                                                    */
/*       : \[XsPsAZuAʂOutTblɊi[     */
/*       : Ȃ                                                   */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int AsmLine( void )
{
FILE	*SourceFD;/* \[Xt@CfBXNv^ */
char Work[MAXLINE+2];/* sf[^擾p[N */
int  rc,i,n,cnt,len,opr;
unsigned short	op,sts;

	/* G[Xe[^X */
	rc = 0;

	/* R[hϊobt@ */
	memset( &OutTbl.idx,0, sizeof(OUTTBL));
	/* s[Nobt@ */
	memset( Work , 0 , sizeof(Work) );

	/* ݂̃AZuAhXo^ */
	OutTbl.adr = (unsigned short)AsmAdr;

	/* t@C؂ւ */
	SourceFD = !IncLevel ? SrcFD : IncFD[IncLevel-1];

	/* \[Xt@CPso */
	rc = GetLine( SourceFD , Work );

	/* CN[ht@CI */
	if ( rc == EOFERR && IncLevel ){
		IncLevel--;
		fclose( IncFD[IncLevel] );
		IncFD[IncLevel] = 0;
		return NORM;
	}

	/* G[󔒍słꍇAI */
	if ( ( rc && ( rc!=EOFERR ) ) || !Work[0]) return rc;

	/* x/jjbN/Iyh/Rgɕ */
	if( rc = GetParam( Work ) ) return rc;
	
	/******************************************/
	/* #if`#else`#endif}N           */
	/******************************************/
	/* jjbNo^ */
	if ( OutTbl.opr[0] ){
		/* ^ߎʃ`FbN */
		ChgCode( oprwk , OutTbl.opr[0] );
		opr = GetMacKind( oprwk );
		switch( opr ){
		case OP_IF:
			/* xIyh2Gg */
			if ( OutTbl.label || OutTbl.opr[2] ) return ILLOPR;
			/* 1Iyhł */
			if( rc = GetCalcData( OutTbl.opr[1] , &op , &sts ) ) return rc;
			/* ̂ȏꍇAI */
			if ( op == LBLNG ) return LBLNOENT;
			/* lXgxAsmFlagۑ */
			IfStk[IfLevel] = AsmFlag;
			/* AZuԂł */
			if (!AsmFlag){
				/* AZu֎~/Zbg */
				AsmFlag = (unsigned char)(sts ? 0 : (!AsmFlag ? 1 : 2 ));
			}
			/* #iflXgx+1 */
			IfLevel++;
			/* lXgxI[o[ */
			if (IfLevel>=IFLEVEL) return IFNEST;
			return NORM;
		case OP_ELSE:
			/* xIyhGg */
			if ( OutTbl.label || OutTbl.opr[1] ) return ILLOPR;
			if ( !IfLevel ) return IFNEST;
			/* ʃlXg̓AZu */
			if ( !IfStk[IfLevel-1] ){
				/* AZuԔ] */
				AsmFlag = (unsigned char)(AsmFlag ? 0 : 1);
			}
			return NORM;
		case OP_ENDIF:
			/* xIyhGg */
			if ( OutTbl.label || OutTbl.opr[1] ) return ILLOPR;
			if ( !IfLevel ) return IFNEST;
			/* #iflXgx-1 */
			IfLevel--;
			if ( IfLevel < 0 ) return IFNEST;
			/* AZuĊJ */
			AsmFlag = IfStk[IfLevel];
			return NORM;
		default:
			break;
		}
	}
	/* AZu֎~Ȃ珈I */
	if ( AsmFlag ) return NORM;

	/******************************************/
	/* V{xo^                 */
	/******************************************/
	/* x */
	if ( OutTbl.label ){
		/* PpXڂł */
		if (!pass){
			/* x`FbN */
			if ( rc = CheckLabel(OutTbl.label) ) return rc;
			/* EQUvł */
			ChgCode( oprwk , OutTbl.opr[0] );
			if (!strcmp( "EQU" , oprwk )){
				/* IyhGgł */
				if ( !OutTbl.opr[1] || OutTbl.opr[2] ) return ILLOPR;
				/* 1Iyhlł */
				if( !(rc = GetCalcData( OutTbl.opr[1] , &op , &sts )) ){
					/* ̂ȏꍇAV{o^Ȃ */
					if ( op == LBLNG ) return NORM;
					/* SETIvVs(ml̂݃V{o^) */
					if ( SetLabel ){
						/* x́A/SET̂ƈv */
						if ( (rc = CheckSetLbl( OutTbl.label, sts )) == 1 ) return NORM;
						/* xo^G[ */
						if ( rc ) return rc;
					}
					/* xe[uɓo^ */
					rc = SetLabelTbl( OutTbl.label, sts );
				}
				/* sI */
				return rc;
			}
			/* EQUȊOł */
			else{
				if ( !StartAdrFlag ) { rc = NOORG; return rc; }/* ORGȂ */
				/* ݂̃AZuAhXxe[uɓo^ */
				if(rc = SetLabelTbl( OutTbl.label, (unsigned short)AsmAdr )) return rc;
			}
		}
		/* QpXڂł */
		else{
			/* EQUvł */
			ChgCode( oprwk , OutTbl.opr[0] );
			if (!strcmp( "EQU" , oprwk )){
				/* ɓo^ς݂Ȃ甲 */
				if ( GetLabelAdr( OutTbl.label , &sts ) != LBLNOENT ) return NORM;
				/* 1Iyhlł */
				if( !(rc = GetCalcData( OutTbl.opr[1] , &op , &sts )) ){
					/* ̂ȏꍇAI */
					if ( op == LBLNG ) return LBLNOENT;
					/* xe[uɓo^ */
					if ( (rc = SetLabelTbl( OutTbl.label, sts )) ) return ILLLBL;
				}
				/* sI */
				return rc;
			}
		}
	}
	/******************************************/
	/* ^/ʖߏ                  */
	/******************************************/
	/* jjbNo^ */
	if ( OutTbl.opr[0] ){
		/* ʏ햽߁^^ߎʃ`FbN */
		ChgCode( oprwk , OutTbl.opr[0] );
		opr = GetMnemonicKind( oprwk );
		switch( opr ){
		case OP_EQU:
			/* xȂEQU(G[I) */
			if ( !pass ) rc = EQUNOLBL;
			break;
		case OP_ORG:
			/* ORG */
			/* QIyhȍ~ɓo^ꍇAG[I */
			if ( OutTbl.opr[2] ){
				rc = ILLOPR;
				break;
			}
			/* IyhGg */
			if ( !OutTbl.opr[1] ) return ILLOPR;
			/* PIyhlł */
			if( !(rc = GetCalcData( OutTbl.opr[1] , &op , &sts )) ){
				/* ̂ȏꍇAI */
				if ( op == LBLNG ){ rc = LBLNOENT; break; }
				if ( sts < (unsigned short)AsmAdr ){
					rc = OFLOW;
					break;
				}
				/* ݂̃AZuAhXXV */
				if ( !StartAdrFlag ){
					StartAdr = sts;
					StartAdrFlag = 1;
				}
				else{
					/* Qڈȍ~́AwoCgmۂ */
					OutTbl.byte = (unsigned short)( sts - (unsigned short)AsmAdr );
				}
				OutTbl.adr = sts;
				AsmAdr = sts;
			}
			break;
		case OP_START:
			/* START */
			/* QIyhȍ~ɓo^ꍇAG[I */
			if ( OutTbl.opr[2] ){
				rc = ILLOPR;
				break;
			}
			/* ExecAdrGg[ */
			if ( ExecAdrFlag ){
				rc = ILLSTART;
				break;
			}
			/* IyhGg */
			if ( !OutTbl.opr[1] ) return ILLOPR;
			/* PIyhlł */
			if( !(rc = GetCalcData( OutTbl.opr[1] , &op , &sts )) ){
				/* ̉ĂꍇAAhXo^ */
				if ( op == LBLOK ){
					/* AhXo^ */
					ExecAdr = sts;
					ExecAdrFlag = 1;
				}
				/* ̖ł2pXڂȂG[I */
				else if (pass){
					rc = LBLNOENT;
				}
			}
			break;
		case OP_DS:
			/* DS */
			if ( !StartAdrFlag ) { rc = NOORG; break; }/* ORGȂ */
			/* QIyhȍ~ɓo^ꍇAG[I */
			if ( OutTbl.opr[2] ){
				rc = ILLOPR;
				break;
			}
			/* PIyhlł */
			if( !(rc = GetCalcData( OutTbl.opr[1] , &op , &sts )) ){
				/* ̂ȏꍇAI */
				if ( op == LBLNG ){ rc = LBLNOENT; break; }
				/* woCgm */
				OutTbl.byte = sts;
				/* AhXXV */
				if (( AsmAdr + sts ) <= MAXOBJ ) AsmAdr += sts;
				else rc = ADOFLOW;
				break;
			}
			rc = ILLOPR;
			break;
		case OP_DB:
			/* DB */
			if ( !StartAdrFlag ) { rc = NOORG; break; }/* ORGȂ */
			/* PIyhȍ~ɓo^ȂꍇAG[I */
			if ( !OutTbl.opr[1] ){
				rc = ILLOPR;
				break;
			}
			cnt = 0;
			i = 0;
			n = 0;
			/* IyhGgo^ */
			while( OutTbl.opr[cnt+1] ){
				/* ȊÓAJ}̃`FbN */
				if ( cnt ){
					/* 擪J}ȊOłꍇAG[I */
					if ( *OutTbl.opr[cnt+1] != ',' ){
						rc = ILLCANMA;
						break;
					}
					/* 擪XLbv */
					i = 1;
				}
				/* ł */
				len = strlen( OutTbl.opr[cnt+1]+i );
				/* 擪эŏI̓R[e[V( = Gg)ł */
				if ( ((*(OutTbl.opr[cnt+1]+i) == 0x22 )&&(*(OutTbl.opr[cnt+1]+i+len-1) == 0x22 ))
					||((*(OutTbl.opr[cnt+1]+i) == 0x27 )&&(*(OutTbl.opr[cnt+1]+i+len-1) == 0x27 )) ){
					/* 񂪂RȉȂIyhُ */
					if( len < 3 ) {
						rc = ILLOPR;
						break;
					}
					/* R[ho^ */
					memcpy( &OutTbl.code[n] , OutTbl.opr[cnt+1]+i+1 , len-2 );
					n += ( len - 2 );
					rc = NORM;
				}
				else{
					/* vZƂď */
					if ( !(rc = GetCalcData( OutTbl.opr[cnt+1]+i , &op , &sts )) ) {
						/* ͈͊OȂG[ */
						if ( sts >= 256 ){
							rc = OFLOW;
							break;
						}
						/* R[ho^ */
						OutTbl.code[n++] = sts;
					}
					else break;
				}
				OutTbl.byte = (unsigned short)n;
				cnt++;
			}
			/* AhXXV */
			if (( AsmAdr + n ) <= MAXOBJ ) AsmAdr += n;
			else rc = ADOFLOW;
			break;
		case OP_DW:
			/* DW */
			if ( !StartAdrFlag ) { rc = NOORG; break; }/* ORGȂ */
			/* PIyhȍ~ɓo^ȂꍇAG[I */
			if ( !OutTbl.opr[1] ){
				rc = ILLOPR;
				break;
			}
			cnt = 0;
			i = 0;
			n = 0;
			/* IyhGgo^ */
			while( OutTbl.opr[cnt+1] ){
				/* ȊÓAJ}̃`FbN */
				if ( cnt ){
					/* 擪J}ȊOłꍇAG[I */
					if ( *OutTbl.opr[cnt+1] != ',' ){
						rc = ILLCANMA;
						break;
					}
					/* 擪XLbv */
					i = 1;
				}
				/* vZƂď */
				if ( rc = GetCalcData( OutTbl.opr[cnt+1]+i , &op , &sts ) ) break;
				/* [hP(rbOGfBA)ŃR[ho^ */
				OutTbl.code[n++] = (unsigned char)((sts>>8) & 0xff);
				OutTbl.code[n++] = (unsigned char)(sts & 0xff);
				OutTbl.byte = (unsigned short)n;
				cnt++;
			}
			/* AhXXV */
			if (( AsmAdr + n ) <= MAXOBJ ) AsmAdr += n;
			else rc = ADOFLOW;
			break;
		case OP_DL:
			/* DW */
			if ( !StartAdrFlag ) { rc = NOORG; break; }/* ORGȂ */
			/* PIyhȍ~ɓo^ȂꍇAG[I */
			if ( !OutTbl.opr[1] ){
				rc = ILLOPR;
				break;
			}
			cnt = 0;
			i = 0;
			n = 0;
			/* IyhGgo^ */
			while( OutTbl.opr[cnt+1] ){
				
				/* ȊÓAJ}̃`FbN */
				if ( cnt ){
					/* 擪J}ȊOłꍇAG[I */
					if ( *OutTbl.opr[cnt+1] != ',' ){
						rc = ILLCANMA;
						break;
					}
					/* 擪XLbv */
					i = 1;
				}
				/*********************/
				/* 1oCgڎ荞 */
				/*********************/
				/* ł */
				len = strlen( OutTbl.opr[cnt+1]+i );
				/* 擪эŏI̓R[e[V( = Gg)ł */
				if ( ((*(OutTbl.opr[cnt+1]+i) == 0x22 )&&(*(OutTbl.opr[cnt+1]+i+len-1) == 0x22 ))
					||((*(OutTbl.opr[cnt+1]+i) == 0x27 )&&(*(OutTbl.opr[cnt+1]+i+len-1) == 0x27 )) ){
					/* 񂪂RȊOȂIyhُ */
					if( len != 3 ) {
						rc = ILLOPR;
						break;
					}
					/* R[ho^ */
					memcpy( &OutTbl.code[n] , OutTbl.opr[cnt+1]+i+1 , len-2 );
					n += ( len - 2 );
					rc = NORM;
				}
				else{
					/* vZƂď */
					if ( !(rc = GetCalcData( OutTbl.opr[cnt+1]+i , &op , &sts )) ) {
						/* ͈͊OȂG[ */
						if ( sts >= 256 ){
							rc = OFLOW;
							break;
						}
						/* R[ho^ */
						OutTbl.code[n++] = sts;
					}
					else break;
				}
				OutTbl.byte = (unsigned short)n;
				cnt++;
				/*********************/
				/* 2[hڎ荞 */
				/*********************/
				/* Iyho^ȂꍇAG[I */
				if ( !OutTbl.opr[cnt+1] ){
					rc = ILLOPR;
					break;
				}
				/* 擪J}ȊOłꍇAG[I */
				if ( *OutTbl.opr[cnt+1] != ',' ){
					rc = ILLCANMA;
					break;
				}
				/* 擪XLbv */
				i = 1;
				/* vZƂď */
				if ( rc = GetCalcData( OutTbl.opr[cnt+1]+i , &op , &sts ) ) break;
				/* [hP(rbOGfBA)ŃR[ho^ */
				OutTbl.code[n++] = (unsigned char)((sts>>8) & 0xff);
				OutTbl.code[n++] = (unsigned char)(sts & 0xff);
				OutTbl.byte = (unsigned short)n;
				cnt++;
			}
			/* AhXXV */
			if (( AsmAdr + n ) <= MAXOBJ ) AsmAdr += n;
			else rc = ADOFLOW;
			break;
		case OP_INCLUDE:
			/* ɃCN[ht@COPEN */
			if ( IncLevel >= (MAXINC-1) ){ rc = INCERR; break; }
			/* IyhGg */
			if ( !OutTbl.opr[1] ){ rc = ILLOPR; break; }
			if ( (len = strlen(OutTbl.opr[1])) < 3 ){ rc = INCNOFILE; break; }
			/* 擪эŏI͊ʂł */
			if ( ( OutTbl.opr[1][0] == '(' ) && ( OutTbl.opr[1][len-1] == ')' ) ){
				/* CN[ht@Co */
				memset( IncFile , 0 , sizeof(IncFile) );
				memcpy( IncFile , &OutTbl.opr[1][1] , len-2 );
				/* CN[ht@COPEN */
				if ( ( IncFD[IncLevel] = fopen( IncFile ,"rb" ) ) <= 0 ){ rc = INCNOFILE; break; }
				/* sԍNA(̏I+1̂-1Zbg) */
				IncLine[IncLevel] = -1;
				/* CN[hLEVELXV */
				IncLevel++;
				rc = NORM;
			}
			else rc = ILLOPR;
			break;
		case OP_INCBIN:
			/* IyhGg */
			if ( !OutTbl.opr[1] ){ rc = ILLOPR; break; }
			if ( (len = strlen(OutTbl.opr[1])) < 3 ){ rc = INCNOFILE; break; }
			/* 擪эŏI͊ʂł */
			if ( ( OutTbl.opr[1][0] == '(' ) && ( OutTbl.opr[1][len-1] == ')' ) ){
				/* oCit@Co */
				memset( BinFile , 0 , sizeof(BinFile) );
				memcpy( BinFile , &OutTbl.opr[1][1] , len-2 );
				/* oCit@Cǂݏo */
				rc = IncludeBin( &OutTbl.byte , BinFile );
				/* AhXXV */
				AsmAdr += OutTbl.byte;
			}
			else rc = ILLOPR;
			break;
		case OP_LIST:
			/* IyhGg */
			if ( OutTbl.opr[1] ) rc = ILLOPR;
			ListFlag = 0;
			break;
		case OP_NOLIST:
			/* IyhGg */
			if ( OutTbl.opr[1] ) rc = ILLOPR;
			/* Xgo͋֎~ */
			ListFlag = 1;
			break;
		case OP_EJECT:
			/* IyhGg */
			if ( OutTbl.opr[1] ) rc = ILLOPR;
			/* XgLineFeed}vZbg */
			LineFeed = 1;
			break;
		/****************/
		/* ʖߏ */
		/****************/
		default:
			/* jjbN͐ */
			if ( strlen( OutTbl.opr[0] ) >= MAXMN ) { rc = UNDEFOPR ; break; }
			/* ORGȂ */
			if ( !StartAdrFlag ) { rc = NOORG; break; }
			/* PIyh */
			if ( OutTbl.opr[1] ){
				/* PIyhlł */
				if( !(rc = GetCalcData( OutTbl.opr[1] , &op , &sts )) ){
					/* ̉ĂꍇAlo^ */
					if ( op == LBLOK ){
						/* lo^ */
						OutTbl.opdata[0] = sts;
					}
					/* ̖ł2pXڂȂG[I */
					else if (pass){
						rc = LBLNOENT;
					}
					/* Iyho^ */
					OutTbl.op = 1;
				}
			}
			/* QIyh */
			if ( OutTbl.opr[2] ){
				/* QIyhlł */
				if( !(rc = GetCalcData( OutTbl.opr[2]+1 , &op , &sts )) ){
					/* ̉ĂꍇAlo^ */
					if ( op == LBLOK ){
						/* lo^ */
						OutTbl.opdata[1] = sts;
					}
					/* ̖ł2pXڂȂG[I */
					else if (pass){
						rc = LBLNOENT;
					}
					/* Iyho^XV */
					OutTbl.op++;
				}
			}
			/* jjbN啶ɕϊ */
			ChgCode( oprwk , OutTbl.opr[0] );
			/* ߃e[u */
			for ( i = 0 ; i < MAXOP ; i++ ){
				/* Y߂ */
				if (!strcmp( oprwk , codetbl[i].name )){
					/* ߃CfbNXi[ */
					OutTbl.idx = (unsigned short)i;
					/* ߃oCgo */
					OutTbl.byte = codetbl[i].byte;
					/* AZuAhXXV */
					AsmAdr += OutTbl.byte;
					return NORM;
				}
			}
			
			/* ߃^Cvُ */
			rc = UNDEFOPR;
			break;
		}
	}
	return rc;
}

/**********************************************************************/
/*   AsmCodeSet : Assembler Process ( 2 pass )                        */
/*                                                                    */
/*       : Ps̃AZuʂR[hiQpX)        */
/*       : Ȃ                                                   */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int AsmCodeSet( void )
{
int  rc;
unsigned short sts,adr;

	/* G[Xe[^X */
	rc = NORM;

	/* AZuAhXXV */
	adr = OutTbl.adr;

	/******************************************/
	/* if`else`endif}N              */
	/******************************************/
	/* jjbNo^ */
	if ( OutTbl.opr[0] ){
		/* if,else,endif`FbN */
		ChgCode( oprwk , OutTbl.opr[0] );
		sts = (unsigned short)GetMacKind( oprwk );
		switch( sts ){
		case OP_IF:
		case OP_ELSE:
		case OP_ENDIF:
			return NORM;
		default:
			break;
		}
	}
	/******************************************/
	/* ^/ʖߏ                  */
	/******************************************/
	/* jjbNo^ */
	if ( OutTbl.opr[0] ){
		/* ʏ햽߁^^ߎʃ`FbN */
		ChgCode( oprwk , OutTbl.opr[0] );
		sts = GetMnemonicKind( oprwk );
		switch(sts){
		case OP_ORG:
		case OP_EQU:
		case OP_DS:
		case OP_DB:
		case OP_DW:
		case OP_DL:
		case OP_INCLUDE:
		case OP_LIST:
		case OP_NOLIST:
		case OP_EJECT:
		case OP_INCBIN:
			break;
		case OP_START:
			/* START */
			/* sJnAhX擪AhX菬ꍇ̓G[I */
			if ( ExecAdrFlag && ( StartAdr > ExecAdr ) ) return EOFLOW;
			break;
		/* ʖ */
		default:
			/* ʖߓo^ */
			if ( OutTbl.byte ){
				/* ߃R[ho */
				OutTbl.code[0] = codetbl[OutTbl.idx].code;
				/* R[hʂɂ镪 */
				switch( codetbl[OutTbl.idx].kind ){
				/* Iyhi1oCg߁j   */
				case OP_NUL:
					/* 1Iyhȍ~ɓo^ꍇAG[I */
					if ( OutTbl.opr[1] ){
						rc = ILLOPR;
					}
					break;
				/* 8rbgIyh(2oCg)  */
				case OP_8:
					/* PIyho^Ȃ */
					if( !OutTbl.op ){
						rc = ILLOPR;
						break;
					}
					/* ͈̓`FbN */
					if ( OutTbl.opdata[0] >= IM8bit ){
						rc = OFLOW;
						break;
					}
					/* IyR[ho^ */
					OutTbl.code[1] = (unsigned char)OutTbl.opdata[0];
					break;
				/* 16rbgIyh(3oCg) */
				case OP_16:
					/* PIyho^Ȃ */
					if( !OutTbl.op ){
						rc = ILLOPR;
						break;
					}
					/* IyhR[ho */
					OutTbl.code[1] = (unsigned char)( OutTbl.opdata[0] >> 8 );
					OutTbl.code[2] = (unsigned char)( OutTbl.opdata[0] & 0xff );
					break;
				/* + ΃Wv߁i2oCg߁j*/
				case OP_JRP:
					/* PIyho^Ȃ */
					if( !OutTbl.op ){
						rc = ILLOPR;
						break;
					}
					/* AhX͈̓`FbN */
					if ( (OutTbl.opdata[0] > ( adr + IM8bit ))||( OutTbl.opdata[0] <= adr ) ){
						rc = OFLOW;
						break;
					}
					/* ΃Wvf[^o */
					OutTbl.code[1] = (unsigned char)(OutTbl.opdata[0] - adr - 1 );
					break;
				/* - ΃Wv߁i2oCg߁j*/
				case OP_JRM:
					/* PIyho^Ȃ */
					if( !OutTbl.op ){
						rc = ILLOPR;
						break;
					}
					/* AhX͈̓`FbN */
					if ( (OutTbl.opdata[0] <= ( adr - IM8bit ))||( OutTbl.opdata[0] > adr ) ){
						rc = OFLOW;
						break;
					}
					/* ΃Wvf[^o */
					OutTbl.code[1] = (unsigned char)(adr - OutTbl.opdata[0] + 1 );
					break;
				/* LP߁i1oCg߁j           */
				case OP_LP:
					/* PIyho^Ȃ */
					if( !OutTbl.op ){
						rc = ILLOPR;
						break;
					}
					/* ͈̓`FbN */
					if ( OutTbl.opdata[0] >= IM6bit ){
						rc = OFLOW;
						break;
					}
					/* IyR[ho^ */
					OutTbl.code[0] |= (unsigned char)OutTbl.opdata[0];
					break;
				/* CAL߁i2oCg߁j          */
				case OP_CAL:
					/* PIyho^Ȃ */
					if( !OutTbl.op ){
						rc = ILLOPR;
						break;
					}
					/* ͈̓`FbN */
					if ( OutTbl.opdata[0] >= IM13bit ){
						rc = OFLOW;
						break;
					}
					/* IyhR[ho */
					OutTbl.code[0] |= (unsigned char)( OutTbl.opdata[0] >> 8 );
					OutTbl.code[1] = (unsigned char)( OutTbl.opdata[0] & 0xff );
					break;
				/* CASE1߁i1oCg߁j        */
				case OP_CASE1:
					/* PAQIyh܂œo^ĂȂ΃G[I */
					if( OutTbl.op != 2 ){
						rc = ILLOPR;
						break;
					}
					/* IyR[h1o^ */
					OutTbl.code[1] = (unsigned char)OutTbl.opdata[0];
					/* IyR[h2o^ */
					OutTbl.code[2] = (unsigned char)( OutTbl.opdata[1] >> 8 );
					OutTbl.code[3] = (unsigned char)( OutTbl.opdata[1] & 0xff );
					break;
				/* CASE2߁i1oCg߁j        */
				case OP_CASE2:
					/* 1Iyhȍ~ɓo^ꍇAG[I */
					if ( OutTbl.opr[1] ){
						rc = ILLOPR;
					}
					break;
				default:
					rc = UNDEFOPR;
					break;
				}
			}
			break;
		}
	}
	return rc;
}
/**********************************************************************/
/*   GetLine : Get Source Line                                        */
/*                                                                    */
/*       : \[Xt@CPs̕擾             */
/*       : \[Xt@C                                       */
/*       : ̓t@ChcAo̓obt@|C^                 */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int GetLine( FILE *fd ,char *buff )
{
int	sts;
int	i;
	/* 1sI܂Ŏo */
	for( i = 0 ; i < MAXLINE ; i++ ){
		/* 1o */
		sts = fgetc( fd );
		switch ( sts ){
		case '\r':
			break;
		/* PsI */
		case '\n':
			return NORM;
		/* t@CI */
		case 0x1a:
		case EOF:
			return EOFERR;
		default:
			*buff++ = ( char )sts;
			break;
		}
	}
	return LOFLOW;
}

/**********************************************************************/
/*   GetParam : Get Parameter String                                  */
/*                                                                    */
/*       : ep[^擾                           */
/*       : sobt@|C^                                     */
/*   o    : G[i0:A0ȊO:YȂj             */
/*                                                                    */
/**********************************************************************/
/* 
 F^ꂽ[Nobt@̕p[^ɕOutTblɓo^B
       Tv͈ȉ̒ʂB
      (1)s擪ɂ^u^Xy[X͍폜B
      (2)ŏ̕ɃR[:]oƃxƂĊi[B
      (3)jjbNo^[&][$][(]^uXy[XoƉsăIyhƂĊi[B
      (4)̐擪ȊOɃJ}[,]oƉsiCfbNXXVjB
      (5)擪́Aʓ[( ` )]ɋLqꂽ^u^Xy[X͋l߂Ċi[B
       i^u^Xy[X͊{IɊi[Ȃj
        A3Iyhȍ~AJR^OoꍇͤXy[X1}B
      (6)_uR[e[V["]oƁA["]oꂷ邩s܂ł̂܂܊i[B
      (7)Z~R[;]oƁAȍ~As܂łRgƂēo^B
        _uR[e[V͂̂܂ܓo^B
      (8)KCΉŁA擪ȊO̊[(]oɑO̕[!+-*^|^%,($]ȊȌꍇA
         sB̎AKCtOONɂB(jjbNϊ̑Ó`FbNׁj
      (9)VOR[e[V[']oƁA[']oꂷ邩s܂ł̂܂܊i[B
         _uR[e[VƂ͔r삷B
*/
int GetParam( char *buff )
{
int	len;
int	j,n;
int label;
int kakko;
int dq,sq;
char *Opr;
	/* Iyhobt@|C^ */
	OutTbl.opr[0] = OutTbl.line;
	Opr = OutTbl.line;

	/* 1sI܂Ŏo */
	len = strlen( buff );
	for(  j = 0 , n = 0 ,label = 0,kakko = 0 ,dq = 0,sq = 0 ; ( n < MAXOPR )&&( j <len ) ; buff++ ){
		switch ( *buff & 0xff ){
		case '#':
		case ';':
			/* Rgo */
			/* R[eV */
			if ( dq || sq ){
				/* p[^o^ */
				Opr[j++] = *buff;
				break;
			}
			/* Rg|C^ݒ */
			OutTbl.comment = Opr+j+1;
			/* c̕RgƂĊi[ */
			memcpy( OutTbl.comment , buff , strlen(buff));
			/* GĝȂIyh|C^NULLɂ */
			if (!j)	OutTbl.opr[n] = 0;
			return NORM;
		case '\n':
		case 0x0:
			/* soŏI */
			/* ʂуR[e[VȂG[ */
			if ( kakko || dq || sq ){
				return ILLDQUO;
			}
			/* GĝȂIyh|C^NULLɂ */
			if (!j) OutTbl.opr[n] = 0;
			return NORM;
		case ':':
			/* R[eV/ʓ */
			if ( dq || sq || kakko ){
				/* p[^o^ */
				Opr[j++]=*buff;
				break;
			}
			/* xo */
			if ( !label && !n ){
				/* xo^ */
				if ( j > MAXNAME ) return LBOFLOW;
				OutTbl.label = Opr;
				/* i[obt@|C^XV */
				Opr += j + 1;
				OutTbl.opr[0] = Opr;
				j = 0;
				label++;
				break;
			}
			/* Qdx̓G[I */
			else if (!n) return ILLLBL;
			return ILLOPR;
		case ',':
			/* s̓rŃJ}o */
			if ( !dq && !sq && j ){
				/* s */
				Opr += j + 1;
				OutTbl.opr[++n] = Opr;
				j = 0;
			}
			/* p[^o^ */
			Opr[j++]=*buff;
			break;
		case ')':
			/* p[^o^ */
			Opr[j++]=*buff;
			/* R[eV */
			if ( dq || sq ) break;
			/* Ƃʌo */
			if ( kakko ){
				kakko--;
				break;
			}
			/* G[I */
			else return ILLDQUO;
		case 0x20:
		case '\t':
#if 0
			/* QIyhȍ~łAJR^Oł */
			if ( (n >= 2)&&( j == 3 )&&
				( !strcmp( &Opr[0],",jr" )||!strcmp( &Opr[0],",JR" ) ) ){
				/* Xy[XƂēo^ */
				Opr[j++] = 0x20;
				break;
			}
#endif
			/* R[e[V͓o^ */
			if ( dq || sq ){
				/* p[^o^ */
				Opr[j++]=*buff;
				break;
			}
			/* 擪ʓȂǂݔ΂ */
			if ( !j ) break;
			/* jjbNo^Ȃ΁As */
			if ( !n ){
				/* s */
				Opr += j + 1;
				OutTbl.opr[++n] = Opr;
				j = 0;
			}
			break;
		/* VOR[e[V}[No */
		case 0x27:
			/* _uR[e[VȂAp[^o^ */
			if ( dq ){
				Opr[j++]=*buff;
				break;
			}
			/* VOR[e[V}[No */
			if ( !sq ){
				sq++;
				/* 擪Iyhł */
				if ( j && !n ){
					/* s */
					Opr += j + 1;
					OutTbl.opr[++n] = Opr;
					j = 0;
				}
				/* p[^o^ */
				Opr[j++]=*buff;
			}
			else{
				sq--;
				/* p[^o^ */
				Opr[j++]=*buff;
			}
			break;
		case 0x22:
			/* VOR[e[VȂAp[^o^ */
			if ( sq ){
				Opr[j++]=*buff;
				break;
			}
			/* _uR[e[V}[No */
			if ( !dq ){
				dq++;
				/* 擪Iyhł */
				if ( j && !n ){
					/* s */
					Opr += j + 1;
					OutTbl.opr[++n] = Opr;
					j = 0;
				}
				/* p[^o^ */
				Opr[j++]=*buff;
			}
			else{
				dq--;
				/* p[^o^ */
				Opr[j++]=*buff;
			}
			break;
		case 'u':
		case 'U':
			/* p[^o^ */
			Opr[j++]=*buff;
			/* 1IyhłAEQUł */
			if ( (n == 1)&&( j == 3 )&&
				( !strcmp( &Opr[0],"equ" )||!strcmp( &Opr[0],"EQU" ) ) ){
				/* 擪p[^xɕϊ */
				OutTbl.label = OutTbl.opr[0];
				OutTbl.opr[0] = OutTbl.opr[1];
				/* s */
				Opr += j + 1;
				OutTbl.opr[n] = Opr;
				j = 0;
				break;
			}
			break;
		case '(':
			/* ʌo */
			if ( !dq && !sq ) kakko++;
#if 0
			/* PO̕ZqуJ}ȊO̎As(KCΉ) */
			if ( n && j && !dq && !sq ){
				if ( !strchr( "!+-*/|^%=<>,($&" , Opr[j-1] ) ){
					/* KCtOZbg */
					Opr += j + 1;
					OutTbl.opr[++n] = Opr;
					j = 0;
				}
			}
#endif
		case '+':
		case '-':
		case '&':
		case '$':
			/* ̕擪IyhŌoꂽꍇAs */
			if ( !n && !dq && !sq && j){
				Opr += j + 1;
				OutTbl.opr[++n] = Opr;
				j = 0;
			}
		default:
			/* LȊȌꍇAp[^o^ */
			Opr[j++]=*buff;
			break;
		}
		/* őIyhzꍇAI */
		if ( j >= MAXLEN ) return OPOFLOW;
	}
	/* ʂуR[e[VȂG[ */
	if ( kakko || dq || sq ) return ILLDQUO;

	/* I */
	return NORM;
}

/**********************************************************************/
/*   SetLabelTbl : Entry Label table                                  */
/*                                                                    */
/*       : xe[uɃxƃAhXo^             */
/*       : x|C^Ao^AhXli0:ȊOj               */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int SetLabelTbl( char * buff , unsigned short adr )
{
LBL * Label;
LBL * Labelwk;

	/* 擪x|C^Zbg */
	Label = LabelTbl;
	while( Label ){
		/* Yx */
		if (!strcmp( Label->name , buff )){
			/* ɓ̂gĂꍇAG[I */
			return DUPLBL;
		}
		/* ŏIxAhXB */
		if ( !Label->np ) break;
		/* x|C^XV */
		Label = Label->np;
	}
	/* xe[um */
	if ( Labelwk = (LBL *)malloc( sizeof(LBL)+strlen(buff) ) ){
		memset( Labelwk , 0 , sizeof(LBL)+strlen(buff) );
	}
	else return LBNOALOC;

	/* o^Ȃ擪|C^ɓo^ */
	if ( !LabelTbl ) LabelTbl = Labelwk;
	/* mۂ|C^|C^Ƃēo^ */
	else Label->np = Labelwk;

	/* x|C^XV */
	Label = Labelwk;
	/* x̂e[uɓo^ */
	memcpy( Label->name , buff , strlen(buff) );
	/* ݂̃AZuAhXxe[uɓo^ */
	Label->adr = adr;
	/* xo^XV */
	LabelCnt++;

	return NORM;
}

/**********************************************************************/
/*   GetLabelAdr : Get Label Address                                  */
/*                                                                    */
/*       : xAhX                         */
/*       : x|C^Ao^AhXl                         */
/*   o    : G[i0:A0ȊO:xGgȂj       */
/*                                                                    */
/**********************************************************************/
int GetLabelAdr( char * buff , unsigned short * adr )
{
LBL * Label;
	/* 擪x|C^Zbg */
	Label = LabelTbl;
	while( Label ){
		/* Yx */
		if (!strcmp( Label->name , buff )){
			/* xAhXԂ */
			*adr = Label->adr;
			return NORM;
		}
		/* x|C^XV */
		Label = Label->np;
	}
	return LBLNOENT;
}

/**********************************************************************/
/*   GetMacKind : Get Macro Kind                                      */
/*                                                                    */
/*       : }Nʂ肷                                   */
/*       : Iyh|C^                                     */
/*   o    : jjbN                                         */
/*                                                                    */
/**********************************************************************/
int GetMacKind( char * buff )
{
int	i;
	/* ^߃e[uT[` */
	for ( i = 0 ; i < MACDIR ; i++ ){
		if (!strcmp( buff , MacTbl[i].name ))
			/* ^߃R[hԂ */
			return MacTbl[i].code;
	}
	/* YȂiʖ߁jԂ */
	return UNDEFOPR;
}

/**********************************************************************/
/*   GetMnemonicKind : Get Mnemonic Kind                              */
/*                                                                    */
/*       : jjbNʂ肷                               */
/*       : Iyh|C^                                     */
/*   o    : jjbN                                         */
/*                                                                    */
/**********************************************************************/
unsigned short GetMnemonicKind( char * buff )
{
int	i;
	/* ^߃e[uT[` */
	for ( i = 0 ; i < MAXDIR ; i++ ){
		if (!strcmp( buff , Directivetbl[i].name ))
			/* ^߃R[hԂ */
			return Directivetbl[i].code;
	}
	/* YȂiʖ߁jԂ */
	return UNDEFOPR;
}
/**********************************************************************/
/*   CheckLabel : Check Label String                                  */
/*                                                                    */
/*       : x̌S`FbN                     */
/*       : Iyh|C^                                     */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int CheckLabel( char * buff )
{
int	i,len;

	/* x񒷃`FbN */
	len = strlen( buff );
	if( !len  ) return ILLOPR;
	if( len > MAXNAME ) return OPOFLOW;
	/* 擪ł͂Ȃ */
	if( strchr( DecStr , buff[0] ) ) return ILLLBL;
	/* xps */
	for( i = 0 ; i < len ; i++ ){
		/* x`FbN */
		if( !strchr( LabelStr , buff[i] ) ) return ILLLBL;
	}
	/* I */
	return NORM;
}
/**********************************************************************/
/*   ChgCode : Change String code  (abc...->ABC...)                   */
/*                                                                    */
/*       : At@xbg啶ɕϊ                 */
/*       : Iyh|C^Ao̓obt@|C^               */
/*   o    : ϊ                                           */
/*                                                                    */
/**********************************************************************/
int ChgCode( char * dst , char * src )
{
int	i,len;
	/* o͐敶NA */
	dst[0] = 0;
	if (! src ) return 0;
	/* Iyh񒷃`FbN */
	len = strlen( src );
	if( !len || ( len > MAXLEN ) ) return 0;
	/* ϊ */
	for( i = 0 ; i < len ; i++ ){
		/* `FbN */
		if( (src[i] >= 'a')&&(src[i] <= 'z') ){
			/* At@xbgȂ啶ɕϊ */
			dst[i] = (char)(src[i] - 0x20);
		}
		else{
			/* ̂܂܃Rs[ */
			dst[i] = src[i];
		}
	}
	/* ŏINull} */
	dst[i] = 0;
	return len;
}

/**********************************************************************/
/*   GetCalcData : Get Calculate Data                                 */
/*                                                                    */
/*       : Ƃė^ꂽvZ                     */
/*       : 擪|C^Ao^AhXl                     */
/*   o    : G[i0:A0ȊO:G[j                 */
/*           : (kind)  LBLOK(̉ς)LBLNG(̖)      */
/*           : vZl(adr) LBLOK̂ݗLBȊO͕sl          */
/**********************************************************************/
int GetCalcData( char * buff , unsigned short * kind ,unsigned short * adr )
{
int rc;
unsigned short val;

	/* IyhGg */
	if ( !buff ) return ILLOPR;

	/* vZp񂠂 */
	if ( !strlen(buff) ) return ILLOPR;

	/* vZobt@ */
	CalcPtr = 0;
	memset( calcwk , 0 , sizeof(calcwk) );
	/* w肠 */
	if ( (buff[0]=='-') || (buff[0]=='+') )
		sprintf( calcwk , "0%s" , buff );
	else
		sprintf( calcwk , "%s" , buff );

	/* ̉ς݃Zbg */
	Ckind = LBLOK;

	/* vZ */
	if ( rc = CalcVal( &val ) ) return rc;

	/* 2pXڂɖ`x */
	if ( pass && (Ckind==LBLNG) ) return LBLNOENT;

	/* I */
	*adr = val;
	*kind = Ckind;
	return NORM;
}

/**********************************************************************/
/*   CalcVal : Calculate compare Logical                              */
/*                                                                    */
/*       : ^ꂽrZ(D揇ʍŒ)           */
/*       : l|C^                                           */
/*   o    : G[i0:A0ȊO:G[j                     */
/*           : vZl(value)                                          */
/*                                                                    */
/**********************************************************************/
int CalcVal(unsigned short * value )
{
int rc;
unsigned short val,wval;

	/* 擪̒l擾 */
	if( rc = CalcVal0( &val ) ) return rc;
	while( 1 ){
		switch( calcwk[CalcPtr] ){
		/* =  */
		case '=':
			CalcPtr ++;
			if ( calcwk[CalcPtr] == '>' ){
				CalcPtr ++;
				if ( rc = CalcVal0( &wval ) ) return rc;
				val = (unsigned short)(val >= wval);
				break;
			}
			if ( calcwk[CalcPtr] == '<' ){
				CalcPtr ++;
				if ( rc = CalcVal0( &wval ) ) return rc;
				val = (unsigned short)(val <= wval);
				break;
			}
			if ( rc = CalcVal0( &wval ) ) return rc;
			val = (unsigned short)(val == wval);
			break;
		/* >  */
		case '>':
			CalcPtr ++;
			if ( calcwk[CalcPtr] == '=' ){
				CalcPtr ++;
				if ( rc = CalcVal0( &wval ) ) return rc;
				val = (unsigned short)(val >= wval);
				break;
			}
			if ( calcwk[CalcPtr] == '<' ){
				CalcPtr ++;
				if ( rc = CalcVal0( &wval ) ) return rc;
				val = (unsigned short)(val != wval);
				break;
			}
			if ( rc = CalcVal0( &wval ) ) return rc;
			val = (unsigned short)(val > wval);
			break;
		/* <  */
		case '<':
			CalcPtr ++;
			if ( calcwk[CalcPtr] == '=' ){
				CalcPtr ++;
				if ( rc = CalcVal0( &wval ) ) return rc;
				val = (unsigned short)(val <= wval);
				break;
			}
			if ( calcwk[CalcPtr] == '>' ){
				CalcPtr ++;
				if ( rc = CalcVal0( &wval ) ) return rc;
				val = (unsigned short)(val != wval);
				break;
			}
			if ( rc = CalcVal0( &wval ) ) return rc;
			val = (unsigned short)(val < wval);
			break;
		case '(':
			return CALERR;
		/* I */
		default:
			*value = val;
			return NORM;
		}
	}
}

/**********************************************************************/
/*   CalcVal0 : Calculate Logical                                     */
/*                                                                    */
/*       : ^ꂽ_Z(D揇+1)             */
/*       : l|C^                                           */
/*   o    : G[i0:A0ȊO:G[j                     */
/*           : vZl(value)                                          */
/*                                                                    */
/**********************************************************************/
int CalcVal0(unsigned short * value )
{
int rc;
unsigned short val,wval;

	/* 擪̒l擾 */
	if( rc = CalcValShift( &val ) ) return rc;
	while( 1 ){
		switch( calcwk[CalcPtr] ){
		/* AND */
		case '&':
			CalcPtr ++;
			if ( rc = CalcValShift( &wval ) ) return rc;
			val &= wval;
			break;
		/* OR */
		case '|':
			CalcPtr ++;
			if ( rc = CalcValShift( &wval ) ) return rc;
			val |= wval;
			break;
		/* XOR */
		case '^':
			CalcPtr ++;
			if ( rc = CalcValShift( &wval ) ) return rc;
			val ^= wval;
			break;
		case '(':
			return CALERR;
		/* I */
		default:
			*value = val;
			return NORM;
		}
	}
}

/**********************************************************************/
/*   CalcValShift : Calculate Shift.                                  */
/*                                                                    */
/*       : ^ꂽVtgZ(D揇+2)           */
/*       : l|C^                                           */
/*   o    : G[i0:A0ȊO:G[j                     */
/*           : vZl(value)                                          */
/*                                                                    */
/**********************************************************************/
int CalcValShift(unsigned short * value )
{
int rc;
unsigned short val,wval;

	/* 擪l擾 */
	if( rc = CalcVal1( &val ) ) return rc;
	while( 1 ) {
		/* EVtgZ */
		if ( (calcwk[CalcPtr]=='>')&&(calcwk[CalcPtr+1]=='>') ){
			CalcPtr += 2;
			if ( rc = CalcVal1( &wval ) ) return rc;
			val = val>>wval;
		}
		else if ( (calcwk[CalcPtr]=='<')&&(calcwk[CalcPtr+1]=='<') ){
			CalcPtr += 2;
			if ( rc = CalcVal1( &wval ) ) return rc;
			val = val<<wval;
		}
		else {
			*value = val;
			return NORM;
		}
	}
}

/**********************************************************************/
/*   CalcVal1 : Calculate Add/Sub.                                    */
/*                                                                    */
/*       : ^ꂽZ(D揇+3)               */
/*       : l|C^                                           */
/*   o    : G[i0:A0ȊO:G[j                     */
/*           : vZl(value)                                          */
/*                                                                    */
/**********************************************************************/
int CalcVal1(unsigned short * value )
{
int rc;
unsigned short val,wval;

	/* 擪l擾 */
	if( rc = CalcVal2( &val ) ) return rc;
	while( 1 ) {
		switch( calcwk[CalcPtr] ){
		/* Z */
		case '+':
			CalcPtr ++;
			if ( rc = CalcVal2( &wval ) ) return rc;
			val += wval;
			break;
		/* Z */
		case '-':
			CalcPtr ++;
			if ( rc = CalcVal2( &wval ) ) return rc;
			val -= wval;
			break;
		/* I */
		default:
			*value = val;
			return NORM;
		}
	}
}

/**********************************************************************/
/*   CalcVal2 : Calculate Multiple/Divide/Mod.                        */
/*                                                                    */
/*       : ^ꂽ揜Z(D揇+4)               */
/*       : l|C^                                           */
/*   o    : G[i0:A0ȊO:G[j                     */
/*           : vZl(value)                                          */
/*                                                                    */
/**********************************************************************/
int CalcVal2(unsigned short * value )
{
int rc;
unsigned short val,wval;

	/* 擪l擾 */
	if( rc = CalcVal3( &val ) ) return rc;
	while( 1 ) {
		switch( calcwk[CalcPtr] ){
		/* Z */
		case '*':
			CalcPtr ++;
			if ( rc = CalcVal3( &wval ) ) return rc;
			val *= wval;
			break;
		/* Z */
		case '/':
			CalcPtr ++;
			if ( rc = CalcVal3( &wval ) ) return rc;
			/* 0ŏZ */
			if ( !wval ) return CALERR;
			val /= wval;
			break;
		/* ](MOD) */
		case '%':
			CalcPtr ++;
			if ( rc = CalcVal3( &wval ) ) return rc;
			/* 0ŏZ */
			if ( !wval ) return CALERR;
			val %= wval;
			break;
		/* I */
		default:
			*value = val;
			return NORM;
		}
	}
}

/**********************************************************************/
/*   CalcVal3 : Calculate ()                                          */
/*                                                                    */
/*       : ʓ̉Zs(D揇ʍō)                       */
/*       : l|C^                                           */
/*   o    : G[i0:A0ȊO:G[j                     */
/*           : vZl(value)                                          */
/*                                                                    */
/**********************************************************************/
int CalcVal3( unsigned short *value )
{
int rc;
unsigned short val,flag;

	flag = 0;

	/* ]]v */
	if( calcwk[CalcPtr] == '!' ){
		CalcPtr++;
		flag = 1;
	}
	/* ʓł */
	if( calcwk[CalcPtr] == '(' ) {
		CalcPtr++;
		/* ʓ̌vZ͍łD揇ʂ̒Ⴂɍs */
		if( rc = CalcVal( &val ) ) return rc;
		/* ʂĂȂB*/
		if( calcwk[CalcPtr++] != ')' ) return ILLDQUO;
	}
	else{
		/* l܂̓xł */
		if( rc = GetValue( &val ) ) return rc;
	}
	/* wɂlC */
	if ( calcwk[CalcPtr] == '.'){
		CalcPtr++;
		switch( calcwk[CalcPtr] ){
		/* ʌw */
		case 'h':
		case 'H':
			val = (unsigned short)(val >> 8);
			break;
		/* ʌw */
		case 'l':
		case 'L':
			val &= 0xff;
			break;
		/* rbg] */
		case 'n':
		case 'N':
			val = (unsigned short)(~val);
			break;
		default:
			return ILLOPR;
		}
		CalcPtr++;
	}
	/* vZlԂ */
	*value = (unsigned short)(!flag ? val : !val);
	return NORM;
}

/**********************************************************************/
/*   GetValue : Get Data Value                                        */
/*                                                                    */
/*       : x܂͐lAlo                     */
/*       : l|C^                                           */
/*   o    : G[i0:A0ȊO:G[j                     */
/*           : 擾l(value)                                          */
/*           : x̉tO(Ckind) (LBLNG:̖)         */
/*                                                                    */
/**********************************************************************/
int GetValue(unsigned short *value ) {
unsigned short val;
int		i,rc,quo;
char	lblwk[MAXLINE+2];   /* vZl擾px[N   */
char	QuoChar;
	/* f[^ */
	*value = 0;
	/* x/l擾pobt@ */
	memset( lblwk , 0 , sizeof(lblwk) );

	/* Zqo܂ŌJԂ */
	i = 0;
	quo = 0;
	QuoChar = 0;
	while ( 1 ){
		/* 񌟏o */
		if ( !quo ){
			/* R[e[VʁiVO/_u)擾 */
			if ( ( calcwk[CalcPtr] == 0x22 )||( calcwk[CalcPtr] == 0x27 )){
				QuoChar = calcwk[CalcPtr];
				quo ++;
			}
		}
		/* R[e[VH */
		else if ( calcwk[CalcPtr] == QuoChar ) quo ++;
		/* Zq܂NulloɂďI */
		if ( !calcwk[CalcPtr] || (!quo && strchr( "+-*/|^%().<>=" , calcwk[CalcPtr] )) ) break;
		/* 擪ȊO&oŏI */
		if ( !quo && ( calcwk[CalcPtr] == '&' && i ) ) break;
		/* Rs[ */
		lblwk[i++] = calcwk[CalcPtr++];
		/* R[e[VI */
		if ( quo == 2 ) break;
	}
	/* o͐lł */
	if ( rc = GetData( lblwk , &val ) ){
		/* IyhLqlȊO */
		if (rc != ILLOPR ) return rc;
		/* xł */
		if ( rc = CheckLabel( lblwk ) ) return ILLOPR;
		/* xAhXo */
		if ( GetLabelAdr ( lblwk , &val ) ){
			/* x̖Ƃ */
			Ckind = LBLNG;
			val = 0;
		}
	}
	/* ߂lԂ */
	*value = val;
	return NORM;
}

/**********************************************************************/
/*   GetData : Get Immediate Data                                     */
/*                                                                    */
/*       : 񂩂琔lf[^擾                         */
/*       : |C^Af[^|C^                         */
/*   o    : l(data)                                               */
/*           : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int GetData( char *buff , unsigned short * data )
{
int	i,len;
unsigned int sts;
	/* Iyh񒷃`FbN */
	len = strlen( buff );
	if( !len  ) return ILLOPR;
	if( len > MAXLEN ) return OPOFLOW;

	/* 擪эŏI̓R[e[V(=Gg)ł */
	if ( (( buff[0] == 0x22 ) && ( buff[len-1] == 0x22 ))
		|| (( buff[0] == 0x27 ) && ( buff[len-1] == 0x27 )) ){
		/* 񒷂RSł */
		if( len == 3 ){
			/* ʂ͎b16rbglƂ */
			*data = (unsigned short)(buff[1]&0xff);
			return NORM;
		}
		else{
			if( len == 4 ){
				/* ʂ͎b16rbglƂ */
				*data = (unsigned short)( (buff[2]&0xff)|((buff[1]&0xff)<<8) );
				return NORM;
			}
			else return ILLOPR;
		}
	}
	/* Qiwł */
	if ( (buff[0] == '&')&&((buff[1] == 'B')||(buff[1] == 'b')) ){
		for( i = 2 , sts = 0; i < len ; i++ ){
			/* 2iグ */
			sts *= 2;
			/* `FbN */
			switch ( buff[i] ){
			case '1':
				sts |= 0x1;
			case '0':
				break;
			default:
				return ILLOPR;
			}
		}
		/* ͈̓I[o[ł */
		if ( sts >= IM16bit ) return OFLOW;
		/* I */
		*data = (unsigned short )sts;
		return NORM;
	}
	/* PUiwł */
	if ( (buff[0] == '&')||(buff[0] == '$') ){
		for( i = 1 ; i < len ; i++ ){
			/* `FbN */
			if( !strchr( HexStr , (int)buff[i] ) ){
			 return ILLOPR;
			 }
		}
		/* PUiɕϊ */
#if FORDOS
		if ( sscanf( &buff[1] , "%Lx" , &sts ) == EOF ) return ILLOPR;
#else
		if ( sscanf( &buff[1] , "%x" , &sts ) == EOF ) return ILLOPR;
#endif
		/* ͈̓I[o[ł */
		if ( sts >= IM16bit ) return OFLOW;
		/* I */
		*data = (unsigned short)sts;
		return NORM;
	}
	/* POi */
	for( i = 0 ; i < len ; i++ ){
		/* `FbN */
		if( !strchr( DecStr , (int)buff[i] ) ) return ILLOPR;
	}
	/* POiɕϊ */
#if FORDOS
	if ( sscanf( buff , "%Ld" , &sts ) == EOF ) return ILLOPR;
#else
	if ( sscanf( buff , "%d" , &sts ) == EOF ) return ILLOPR;
#endif
	/* ͈̓I[o[ł */
	if ( sts >= IM16bit ) return OFLOW;

	/* I */
	*data = (unsigned short )sts;
	return NORM;
}

/**********************************************************************/
/*   CheckSetOpt : Check /SET Option Name                             */
/*                                                                    */
/*       : /SETIvV̓o^`FbNs               */
/*       : Ȃ                                                   */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int CheckSetOpt( char * name )
{
int	i;
	/* xo^`FbN */
	for ( i = 0 ; i < SetLabel ; i++ ){
		/* o^xƈv */
		if( !strcmp( SetTbl[i].ent , name ) ) return 0;
	}
	return 2;
}

/**********************************************************************/
/*   CheckSetLbl : Check /SET Option Name                             */
/*                                                                    */
/*       : /SETIvV̓o^`FbNs               */
/*       : Ȃ                                                   */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int CheckSetLbl( char * name ,unsigned short sts )
{
int	i,ent,rc;
	ent = 0;
	/* xo^`FbN */
	for ( i = 0 ; i < SetLabel ; i++ ){
		/* o^xƈv */
		if( !strcmp( SetTbl[i].ent , name ) ){
			ent++;
		}
		/* xƈv */
		if( !strcmp( SetTbl[i].let , name ) ){
			/* xe[uɓo^ */
			if( rc = SetLabelTbl( SetTbl[i].ent , sts ) ) return rc;
		}
	}
	/* o^xƈvꍇAxo^Ԃ */
	if ( ent ) return 1;

	/* YȂ */
	return NORM;
}
/**********************************************************************/
/*   IncludeBin : Include BIN/BMP file                                */
/*                                                                    */
/*       : BinarytH[}bg̃t@COutBufɓǂݏo         */
/*       : obt@ʒm|C^                                 */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int IncludeBin( unsigned short *cnt ,char *File )
{
int rc,type;
char * fptr;
unsigned int Size = 0;

	/* obt@|C^ */
	type =0;

	/* gqɂt@Cʂ̔ */
	if ((int)(fptr = strrchr( File,  '.' ))){
		ChgCode( oprwk , fptr );
		/* BMPt@Cł */
		if ( !strcmp(".BMP",oprwk ) ){
			type = 1;
		}
	}
	/* oCit@COPEN */
	if ( ( BinFD = fopen( File ,"rb" ) ) <= 0 ){
		printf("Invalid Binary File Name.\n");
		return ILLBIN;
	}

	if (!type){
		/* oCiǂݏo */
		rc = ReadBin( &Size );
	}
	else{
		/* rbg}bvǂݏo */
		rc = ReadBmp( &Size );
	}

	/* oCit@CN[Y */
	fclose(BinFD);

	/* R[hTCYn */
	*cnt = (unsigned short)Size;
	return rc;
}
/**********************************************************************/
/*   ReadBin : Read BIN file                                          */
/*                                                                    */
/*       : BinarytH[}bg̃t@COutTbl.bcodeɓǂݏo   */
/*       : obt@ʒm|C^                                 */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int ReadBin( unsigned int * Size )
{
unsigned int BuffSize=0;	/* o̓obt@TCY */

	*Size = 0;
	/* t@CTCY擾 */
	if (fseek( BinFD , 0 , SEEK_END )){
		return ILLBIN;
	}
	BuffSize = (unsigned int)ftell( BinFD );
	if (fseek( BinFD , 0 , SEEK_SET )){
		return ILLBIN;
	}
	/* obt@TCY`FbN */
	if ( BuffSize > ( MAXOBJ - AsmAdr )){
		/* ǂݏoTCYI[o[ */
		return ADOFLOW;
	}
	/* 1 passڂȂI */
	if ( !pass ){
		*Size = BuffSize;
		return NORM;
	}
	/* o̓obt@mۂ */
	if ( !(OutTbl.bcode = (unsigned char*)malloc( (size_t)BuffSize ))){
		printf("Output Buffer Not Allocated.\n");
		return ILLBIN;
	}
	/* BINt@Cǂ݂ */
	if ( fread( OutTbl.bcode , (size_t)BuffSize , (size_t)1 , BinFD ) != 1 ){
		printf("File read error.\n");
		return ILLBIN;
	}

	/* obt@Zbg */
	*Size = BuffSize;
	return NORM;
}
/**********************************************************************/
/*   ReadBmp : Read Bitmap file                                       */
/*                                                                    */
/*       : BMPtH[}bg̃t@COutTbl.bcodeɓǂݏo      */
/*       : obt@ʒm|C^                                 */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int ReadBmp( unsigned int * Size )
{
unsigned char ImgTbl[62];
unsigned int bfsize;	/* t@CTCY */
unsigned int boffset;	/* 摜f[^܂ł̃ItZbg */
unsigned int bisize;	/* wb_̑傫 */
unsigned int width;		/* 摜̕ */
unsigned int width2;	/* 摜̕(ۂ̃f[^ʒu) */
unsigned int height;	/* 摜̍ */
unsigned int imgsize;	/* 摜̃TCY */
unsigned short bitcount;/* F */
unsigned short parret1,parret2;/* pbgf[^ */
unsigned int x,y;
unsigned char * ImageTbl=0;/* ǂݏopobt@|C^ */
unsigned int BuffSize=0;	/* o̓obt@TCY */
unsigned int ImgSize=0;	/* 摜obt@TCY */

	*Size = 0;
	/* C[We[u */
	memset( ImgTbl , 0 , sizeof(ImgTbl) );
	/* BMPt@Cwb_ǂݏo(62oCgŒ) */
	if ( fread( ImgTbl , 1 , 62 , BinFD ) != 62 )
		goto bmp_read_error;
	/* BMPwb_ */
	if ( (ImgTbl[0] != 'B')||(ImgTbl[1] != 'M'))
		goto bmp_read_error;
	/* BMPt@CTCY擾 */
	bfsize = Getlong(2);
	/* 摜f[^܂ł̃ItZbg擾 */
	boffset = Getlong(10);
	/* wb_̑傫 */
	bisize = Getlong(14);
	/* wb_TCY`FbN */
	if ( (( bisize != 40 )&&( bisize != 12 ))||( bisize > boffset )||( bfsize <= boffset ) )
		goto bmp_read_error;
	/* BMPp[^擾 */
	switch( bisize ){
	/* Windows`tH[}bgł */
	case 40:
		width = Getlong(18);/*  */
		height = Getlong(22);/*  */
		bitcount = Getword(28);/* F */
		imgsize = Getlong(34);
		parret1 = Getparret(54);
		parret2 = ( (boffset-bisize-14) == 6 ) ? Getparret(57) : Getparret(58);
		break;
	/* OS2`tH[}bgł */
	case 12:
		width = (unsigned int)Getword(18);/*  */
		height = (unsigned int)Getword(20);/*  */
		bitcount = Getword(24);/* F */
		imgsize = 0;
		parret1 = Getparret(26);
		parret2 = ( (boffset-bisize-14) == 6 ) ? Getparret(29) : Getparret(30);
		break;
	/* m̃tH[}bg̏ꍇAG[I */
	default:
		goto bmp_read_error;
	}
	/* mN摜ł */
	if ( bitcount != 1 )
		goto bmp_read_error;
	/* obt@TCY쐬 */
	ImgSize = bfsize - boffset;

	/* 𑜓x̃f[^Mp */
	BuffSize = width * height / 8;

	/* obt@TCY`FbN */
	if ( BuffSize > ( MAXOBJ - AsmAdr )){
		/* ǂݏoTCYI[o[ */
		return ADOFLOW;
	}
	/* 1 passڂȂI */
	if ( !pass ){
		*Size = BuffSize;
		return NORM;
	}
	/* ǂݏoe[umۂ */
	if ( !(ImageTbl = (unsigned char *)malloc( (size_t)ImgSize ))){
		printf("Read Buffer Not Allocated.\n");
		return ILLBMP;
	}
	/* ǂݏoe[u */
	memset( ImageTbl , 0xff , (size_t)ImgSize );
	/* Bitmapf[^ǂݏo */
	if ( fseek( BinFD , boffset , SEEK_SET ) )
		goto bmp_read_error;
	if ( fread( ImageTbl , (size_t)1 , (size_t)ImgSize , BinFD ) != ImgSize )
		goto bmp_read_error;

	/* o̓obt@mۂ */
	if ( !( OutTbl.bcode = (unsigned char *)malloc( (size_t)BuffSize ))){
		printf("Output Buffer Not Allocated.\n");
		/* ǂݏoobt@J */
		free( ImageTbl );
		return ILLBMP;
	}
	/* obt@ */
	memset( OutTbl.bcode, 0 , (size_t)BuffSize );
	/* width␳ */
	width2 = ( width & 0x1f ) ? (width+32)/32*32 : width;
	/* BMP --> oCiϊ */
	for ( x = 0 ; x < width ; x++ ){
		for ( y = 0 ; y < height ; y++ ){
			/* 𔻒肷 */
			if (parret1 < parret2){
				/* if point(x,y) = 0 */
				if ( !(ImageTbl[(height-y-1)*(width2/8)+(x/8)]&((unsigned char)(0x80>>(x&7)))) )
					/* then pset(x,y) */
					OutTbl.bcode[x+((y/8)*width)] |= (unsigned char)(0x01<<(y&7));
			}
			else{
				/* if point(x,y) = 1 */
				if ( (ImageTbl[(height-y-1)*(width2/8)+(x/8)]&((unsigned char)(0x80>>(x&7)))) )
					/* then pset(x,y) */
					OutTbl.bcode[x+((y/8)*width)] |= (unsigned char)(0x01<<(y&7));
			}
		}
	}
	/* ǂݏoobt@J */
	free( ImageTbl );
	*Size = BuffSize;
	return NORM;

bmp_read_error:
	/* ǂݏoobt@J */
	if (ImageTbl) free( ImageTbl );
	return ILLBMP;
}

/**********************************************************************/
/*   PrintList : Print List File                                      */
/*                                                                    */
/*       : OutTblɏ]APs̃Xgo͂                 */
/*       : sԍJE^                                         */
/*   o    : Ȃ                                                   */
/*                                                                    */
/**********************************************************************/
void PrintList( int count )
{
int	i,cnt,n,len;
unsigned short sts;
	/* Xgo͗vȂꍇAI */
	if ( ListFlag ) return;
	len = 0;
	cnt = 0;
	/* sԍo */
	if (pr) printf( "%05d:%04X  " , count+1 , OutTbl.adr );
	fprintf( LstFD ,"%05d:%04X  " , count+1 , OutTbl.adr );

	/* ʏ햽߁^^ߎʎo */
	ChgCode( oprwk , OutTbl.opr[0] );
	sts = GetMnemonicKind( oprwk );
	/* ORG/#INCBIN߈ȊO͖ߌR[ho */
	if (OutTbl.byte && ( sts != OP_ORG )&&( sts != OP_INCBIN ) ){
		/* f[^ */
		for ( cnt = 0 ; cnt < 4 ; cnt++ ){
			if ( cnt < OutTbl.byte){
				/* DSߎ́A0o͂ */
				if ( sts == OP_DS ){
					if (pr) printf( "00" );
					fprintf( LstFD ,"00" );
				}
				 else{
					if (pr) printf( "%02X" , OutTbl.code[cnt] );
					fprintf( LstFD ,"%02X" , OutTbl.code[cnt] );
				}
			}
			else{
				if (pr) printf( "  " );
				if (!Tab) fprintf( LstFD ,"  " );
			}
		}
		if (pr) printf( "  " );
		if (!Tab) fprintf( LstFD ,"  " );
		else fprintf( LstFD ,"%s", ( ( OutTbl.byte & 0x3 ) == 1) ? "\t\t" : "\t" );
	}
	else{
		/* f[^Ȃ */
		if ( sts != OP_INCBIN ) cnt = OutTbl.byte;
		if (pr) printf( "          " );
		if ( !Tab ) fprintf( LstFD ,"          " );
		else fprintf( LstFD ,"\t\t" );
	}
	/* xR[ho */
	if ( OutTbl.label ){
		sprintf( oprwk , "%s:" , OutTbl.label );
		if (pr) printf("%-13s" , oprwk );
		if (!Tab) fprintf( LstFD ,"%-13s" , oprwk );
		else{
			fprintf( LstFD ,"%s" , oprwk );
			if ( strlen(oprwk) < 8 )
				fprintf( LstFD ,"\t" );
		}
	}
	else{
		if ( OutTbl.opr[0] ){
			/* 󔒏o */
			if (pr) printf( "             " );
			if ( !Tab )	fprintf( LstFD ,"             " );
			else fprintf( LstFD ,"\t" );
		}
	}
	/* jjbNo */
	if ( OutTbl.opr[0] ){
		if (pr) printf( "%-08s" , OutTbl.opr[0] );
		if (!Tab) fprintf( LstFD ,"%-08s" , OutTbl.opr[0] );
		else{
			fprintf( LstFD ,"%s" , OutTbl.opr[0] );
			if ( strlen(OutTbl.opr[0]) < 8 )
				fprintf( LstFD ,"\t" );
		}
		len += 8;
	}
	/* Iyho */
	i = 1;
	while( OutTbl.opr[i] ){
		if (pr) printf( "%s" , OutTbl.opr[i] );
		fprintf( LstFD ,"%s" , OutTbl.opr[i] );
		len += strlen(OutTbl.opr[i]);
		i++;
	}
	/* Rgo */
	if ( OutTbl.comment ){
		if (pr) printf( "%s" , OutTbl.comment );
		/* 󔒏o */
		if ( len ){
			if (!Tab){
				n = ( len > 30 ) ? 0 : ( 30 - len );
				for ( i = 0 ; i < n ; i++ ) fprintf( LstFD ," " );
			}
			else{
				n = ( len > 31 ) ? 0 : ( 4 - (len/8) );
				for ( i = 0 ; i < n ; i++ ) fprintf( LstFD ,"\t" );
			}
		}
		fprintf( LstFD ,"%s" , OutTbl.comment );
	}
	/* s */
	if (pr) printf( "\n" );
	fprintf( LstFD ,"\n" );
	/* ߌR[ho */
	while( OutTbl.byte && ( cnt < OutTbl.byte ) ){
		if (pr) printf("            ");
		fprintf(LstFD , "            ");
		/* f[^ */
		for ( i = 0 ; i < 4 ; i++ , cnt++ ){
			if ( cnt < OutTbl.byte){
				/* DSߎ́A0o͂ */
				if ( sts == OP_DS ){
					if (pr) printf( "00" );
					fprintf( LstFD ,"00" );
				}
				 else{
				 	if ( sts != OP_INCBIN ){
						if (pr) printf( "%02X" , OutTbl.code[cnt] );
						fprintf( LstFD ,"%02X" , OutTbl.code[cnt] );
					}
					else{
						if (pr) printf( "%02X" , OutTbl.bcode[cnt] );
						fprintf( LstFD ,"%02X" , OutTbl.bcode[cnt] );
					}
				}
			}
			else{
				if (pr) printf( "  " );
				if (!Tab) fprintf( LstFD ,"  " );
			}
		}
		/* TABo */
		if ( Tab ) {
			fprintf( LstFD ,"\t");
			if ( ( OutTbl.byte & 0x3 ) == 1 ) fprintf( LstFD ,"\t");
		}
		/* incbinjjbNo */
		if ( sts == OP_INCBIN ){
			/* DBߏo */
			if (pr) printf( "               DB      " );
			if ( !Tab ) fprintf( LstFD ,"               DB      " );
			else fprintf( LstFD ,"\tDB\t" );
			for ( n = cnt-i ; n < cnt ; n++){
				if ( n < OutTbl.byte){
					if (pr) printf( "$%02X" , OutTbl.bcode[n] );
					fprintf( LstFD ,"$%02X" , OutTbl.bcode[n] );
					/* J}o */
					if ( ( n < cnt-1 )&&( n < OutTbl.byte-1) ){
						if (pr) printf( "," );
						fprintf( LstFD ,"," );
					}
				}
			}
		}
		/* s */
		if (pr) printf( "\n" );
		fprintf( LstFD ,"\n" );
	}
	/* EJECTv */
	if ( LineFeed ){
		/* Line Feed(0xc)o */
		fprintf( LstFD ,"%c", 0xc );
		/* wb_o */
		fprintf( LstFD , "%s%s - ",name,rev );
		fprintf( LstFD ,"ASSEMBLY LIST OF [%s]\n", SrcFile );
		LineFeed = 0;
	}
}

/**********************************************************************/
/*   ErrPut : Error Print                                             */
/*                                                                    */
/*       : G[bZ[Wo͂                             */
/*       : sԍJE^AG[ԍ                             */
/*   o    : Ȃ                                                   */
/*                                                                    */
/**********************************************************************/
void ErrPut( int cnt , int err )
{
int	i;
	/* G[s̏o */
	pr = 1;
	ListFlag = 0;
	PrintList( cnt );

	/* ̓R[hɊYG[bZ[Wo */
	for ( i = 0 ; i < MAXERR-1 ; i++ ){
		if ( errtbl[i].code==err )	break;
	}
	printf("LINE:%d ERROR CODE:%03d %s\n" , cnt+1, err , errtbl[i].msg );
	fprintf( LstFD ,"LINE:%d ERROR CODE:%03d %s\n" , cnt+1, err , errtbl[i].msg );
}
